// Generated by CoffeeScript 2.3.2
(function() {
  var defaults, diceroll, exports, extend, recurse, typeIsArray;

  defaults = {
    dice: null,
    sides: null,
    sum: true,
    onesSubtract: false,
    target: null,
    explodeOn: null,
    modifier: null
  };

  diceroll = function(opts) {
    var conclusion, diceLeft, result, results, rolls;
    rolls = [];
    conclusion = 0;
    results = [];
    conclusion = 0;
    if (typeIsArray(opts)) {
      return recurse(opts);
    } else {
      opts = extend(extend({}, defaults), opts);
      if (opts.explodeOn !== null && opts.explodeOn <= 1) {
        throw new Error("If you set explodeOn to that number, the roll will keep exploding forever.");
      }
      if (opts.dice === null || opts.sides === null) {
        throw new Error("You have to provide dice and sides parameters");
      }
      if (!opts.sum && opts.target === null) {
        throw new Error("If you set sum: false you must set target: <number> as well.");
      }
      diceLeft = opts.dice;
      while (diceLeft) {
        diceLeft--;
        result = Math.ceil(Math.random() * opts.sides);
        rolls.push(result);
        if (!opts.sum && opts.explodeOn !== null && result >= opts.explodeOn) {
          diceLeft++;
        }
        if (opts.sum) {
          conclusion += result;
        } else if (!opts.sum && result >= opts.target) {
          conclusion++;
        } else if (!opts.sum && opts.onesSubtract && result === 1) {
          conclusion--;
        }
      }
      if (opts.sum && opts.target !== null) {
        conclusion = conclusion >= opts.target;
      }
      if (opts.sum && opts.modifier !== null) {
        conclusion += opts.modifier;
      }
      return {
        'rolls': rolls,
        'conclusion': conclusion
      };
    }
  };

  recurse = function(opts) {
    var conclusion, i, len, opt, result, roll, rolls;
    rolls = [];
    conclusion = 0;
    for (i = 0, len = opts.length; i < len; i++) {
      opt = opts[i];
      roll = diceroll(opt);
      result = roll;
      rolls.push(result.rolls);
      if (typeof result.conclusion === "number") {
        conclusion += result.conclusion;
      }
    }
    return {
      'rolls': rolls,
      'conclusion': conclusion
    };
  };

  // Helper method grabbed from http://coffeescript.org/documentation/docs/helpers.html
  extend = function(object, properties) {
    var key, val;
    for (key in properties) {
      val = properties[key];
      object[key] = val;
    }
    return object;
  };

  // The "Miller Device" grabbed from http://coffeescriptcookbook.com/chapters/arrays/check-type-is-array
  typeIsArray = Array.isArray || function(value) {
    return {}.toString.call(value) === '[object Array]';
  };

  if (typeof module !== "undefined") {
    // Export the module
    exports = module.exports = diceroll;
  }

  if (typeof window !== "undefined") {
    window.diceroll = diceroll;
  }

  return diceroll;

}).call(this);
